package cn.reghao.devops.web.mgr.app.db.query;

import cn.reghao.devops.web.mgr.app.model.po.config.AppConfig;
import cn.reghao.devops.web.mgr.app.model.po.log.BuildLog;
import cn.reghao.devops.web.mgr.app.model.vo.AppBuildingVO;
import cn.reghao.devops.web.mgr.app.model.vo.BuildLogVO;
import cn.reghao.devops.web.mgr.builds.model.po.CompilerConfig;
import cn.reghao.devops.web.mgr.builds.model.po.PackerConfig;
import cn.reghao.devops.web.mgr.builds.model.po.RepoAuthConfig;
import cn.reghao.devops.web.mgr.app.model.vo.AppConfigVO;
import cn.reghao.jutil.jdk.db.BaseQuery;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * @author reghao
 * @date 2021-06-02 15:01:18
 */
public interface AppBuildQuery extends BaseQuery<AppConfig> {
    List<AppConfig> query(Map<String, String> kv);
    AppConfig findByRepoAndBranch(String repo, String branch);
    AppConfig findByAppId(String appId);
    Page<AppConfigVO> findByEnvAndType(String env, String type, Pageable pageable);
    List<AppConfig> findAllByRepoAuthConfig(RepoAuthConfig repoAuthConfig);
    List<AppConfig> findAllByCompilerConfig(CompilerConfig compilerConfig);
    List<AppConfig> findAllByPackerConfig(PackerConfig packerConfig);
    Page<AppBuildingVO> getByPage(String appEnv, String appType, PageRequest pageRequest);
    Page<AppBuildingVO> getPageByName(String appName, PageRequest pageRequest);
    AppConfig getAppConfig(String appId);
    boolean isBuilding(String appId);
    Page<BuildLogVO> buildLogVOs(String appId, PageRequest pageRequest);
    BuildLog findByBuildLogId(String buildLogId);
    String getBuildResult(String buildLogId);
}
